#!/usr/bin/perl

use strict;
use warnings;

my $singlefile = 0;

sub mktrace($$$)
{
    my $bits = shift;
    my $len = shift;
    my $seq = shift;

    my $tracefile = ();
    
    if ($singlefile)
    {
	$tracefile = "gen/bits${bits}/len${len}_${seq}.txt"
    }
    else
    {
	my $xxmark = $len;
	$xxmark =~ s/./x/g;
	$tracefile = "gen/bits${bits}/all_${xxmark}_${seq}.txt"
    }

    # echo $(dirname $TRACEFILE) $TRACEFILE

    open(my $fh, $singlefile ? ">" : ">>", $tracefile) or
	die "Could not open $tracefile.";

    if (!$singlefile)
    {
	print $fh "Event\n";
    }

    my $maxvalue = 1 << $bits;

    # Make the sequences deterministic
    srand "$bits$len$seq";

    # for i in `seq 1 $2` ; do echo $i ; done > $TRACEFILE
    for (my $i = 1; $i < $len; $i++)
    {
	print $fh int(rand $maxvalue)."\n";
    }
}

sub mkseq($$)
{
    my $bits = shift;
    my $len = shift;

    my $maxseq = $len > 0 ? 100/$len : 3;

    if ($maxseq < 1 ) { $maxseq = 1;  }
    if ($maxseq > 10) { $maxseq = 10; }

    for (my $seq = 0; $seq < $maxseq; $seq++)
    {
	mktrace ($bits,$len,$seq);
    }
}

for (my $bits = 1; $bits <= 25; $bits++)
{
    print "Generating for $bits bits\n";

    `mkdir -p gen/bits$bits`;

    for (my $len = 0; $len < 50; $len++)
    {
	mkseq($bits,$len);
    }
	
    for (my $len = 55; $len < 100; $len += 5)
    {
	mkseq($bits,$len);
    }
	
    for (my $len = 125; $len < 500; $len += 25)
    {
	mkseq($bits,$len);
    }
}
